module ops(input a, input b, 
           output c, output reg [2:0] d);

reg [7:0] cnt;
integer i;
reg [3:0] x,y,z;

always @(a) begin
  // if statement example
  if (cnt>10) cnt = 0;
  else cnt = cnt+1;
  
  // for loop example
  for (i=0;i<7;i=i+2) cnt[i] = a|cnt[i]; 
  
  // case example
  case (cnt)
  'b00:    d = 0;
  'b01:    d = 2;
  default: d = 'b111;
  endcase  
  
  // function call example
  z = add(x,y);
end

// function example
function [3:0] add (input [3:0] x,y);
 begin
  add = x+y;
end
endfunction


// logic gate example
xor(c,a,b);  // logical gate, c = a xor b

endmodule